#decoydistribution.py
import sys,os
import numpy as np
import numpy.ma as ma
import matplotlib.pyplot as plt
from matplotlib.widgets import Slider

if '--assess' in sys.argv:
  x=sys.argv[sys.argv.index('--assess')+1]
  xvalue=sys.argv[sys.argv.index('--assess')+2]
else:
  print 'insert values to assess the quality by --assess [file] [type]'
  sys.exit()

if '--maxstruc' in sys.argv:
  border=int(sys.argv[sys.argv.index('--maxstruc')+1])
else:
  print 'All decoys will be regarded'
  border= 1000000
if '--benchmark' in sys.argv:
  structures=sys.argv[sys.argv.index('--benchmark')+1]
  if structures == 'benchmark':
    dirlist = [z for z in os.listdir('.') if os.path.isdir(z)]
    dirlist = np.array(dirlist, dtype=str)
  else:
    dirlist = np.genfromtxt(structures, dtype=str)
else:
  print 'insert file with complexes or choose the whole \'benchmark\''
  sys.exit()
  
classon = False
if '--classification' in sys.argv:
  classon = True
  classtype = sys.argv[sys.argv.index('--classification')+1]
  classfile = sys.argv[sys.argv.index('--classification')+2]
  cobj = open(classfile, 'r')
  com1=[]
  com2=[]
  com3=[]
  for cline in cobj:
    cline = cline.strip()
    cline = cline.split()
    com1.append(cline[0])
    com2.append(cline[1])
    com3.append(cline[2])
  cobj.close()
  comclass=[com1,com2,com3]
  if classtype == 'difficulty':
    setname=['rigid', 'medium', 'hard']
    classes = np.zeros(len(dirlist),dtype = int)
    dictio = { "rigid":0, "medium":1, "hard":2}
    for i, folder in enumerate(dirlist):
      classes[i] = dictio[comclass[1][comclass[0].index(folder)]]
  elif classtype == 'proteintype':
    setname=['enzyme', 'antibody', 'other']
    classes = np.zeros(len(dirlist),dtype=int)
    dictio = { "enzyme":0, "antibody":1, "other":2}
    for i, folder in enumerate(dirlist):
      classes[i] = dictio[comclass[2][comclass[0].index(folder)]]
  dirlist = np.array(dirlist)
  sort = np.argsort(classes)
  dirlist = dirlist[sort]
  classlabel = np.array(setname,dtype = str)
  classlabel = classlabel[classes[sort]]
  trainlen = len(ma.compressed(ma.masked_not_equal(classes,0)))
  testlen = len(ma.compressed(ma.masked_not_equal(classes,1)))
  otherlen = len(ma.compressed(ma.masked_not_equal(classes,2)))

  print setname[0],trainlen
  print setname[1],testlen
  print setname[2],otherlen

if '--statistics' in sys.argv:
      if xvalue=='irmsd':
	if classon:
	  print xvalue,'|  class |   < 1|   < 2|   < 3|   < 4|   < 5|   > 5| total|'
	else:
	  print xvalue,'|   < 1|   < 2|   < 3|   < 4|   < 5|   > 5| total|'
	
	for i, direct in enumerate(dirlist):
	  xi=np.genfromtxt(direct+'/'+x)[:border,-1]
	  num1=len(ma.compressed(ma.masked_outside(xi,0,1)))
	  num2=len(ma.compressed(ma.masked_outside(xi,1,2)))
	  num3=len(ma.compressed(ma.masked_outside(xi,2,3)))
	  num4=len(ma.compressed(ma.masked_outside(xi,3,4)))
	  num5=len(ma.compressed(ma.masked_outside(xi,4,5)))
	  total=len(xi)
	  test=len(ma.compressed(ma.masked_less_equal(xi,5)))
	  if classon:
	    print direct, "%10s" % classlabel[i], "%6s" % str(num1),"%6s" % str(num2),"%6s" % str(num3),"%6s" % str(num4),"%6s" % str(num5), "%6s" % str(test), "%6s" % str(total)
	  else:
	    print direct, "%8s" % str(num1),"%6s" % str(num2),"%6s" % str(num3),"%6s" % str(num4),"%6s" % str(num5), "%6s" % str(test), "%6s" % str(total)
      
      elif xvalue=='lrmsd':
	if classon:
	  print xvalue,'|  class |   < 2|   < 4|   < 6|   < 8|   < 10|   > 10| total|'
	else:  
	  print xvalue,'|   < 2|   < 4|   < 6|   < 8|   < 10|   > 10| total|'
	for i, direct in enumerate(dirlist):
	  xi=np.genfromtxt(direct+'/'+x)[:border,-1]
	  num1=len(ma.compressed(ma.masked_outside(xi,0,2)))
	  num2=len(ma.compressed(ma.masked_outside(xi,2,4)))
	  num3=len(ma.compressed(ma.masked_outside(xi,4,6)))
	  num4=len(ma.compressed(ma.masked_outside(xi,6,8)))
	  num5=len(ma.compressed(ma.masked_outside(xi,8,10)))
	  total=len(xi)
	  test=len(ma.compressed(ma.masked_less_equal(xi,10)))
	  if classon:
	    print direct, "%10s" % classlabel[i], "%6s" % str(num1),"%6s" % str(num2),"%6s" % str(num3),"%7s" % str(num4),"%7s" % str(num5), "%6s" % str(test), "%6s" % str(total)
	  else:
	    print direct, "%8s" % str(num1),"%6s" % str(num2),"%6s" % str(num3),"%7s" % str(num4),"%7s" % str(num5), "%6s" % str(test), "%6s" % str(total)

      elif xvalue=='capristars':
	if classon:
	  print xvalue,'|  class | high | medium | acceptable | notacceptable | total|'
	else:
	  print xvalue,'| high | medium | acceptable | notacceptable | total|'
	for i,direct in enumerate(dirlist):
	  xi=np.genfromtxt(direct+'/'+x)[:border]
	  num1=len(ma.compressed(ma.masked_not_equal(xi,3)))
	  num2=len(ma.compressed(ma.masked_not_equal(xi,2)))
	  num3=len(ma.compressed(ma.masked_not_equal(xi,1)))
	  num4=len(ma.compressed(ma.masked_not_equal(xi,0)))
	  total=len(xi)
	  if classon:
	    print direct, "%10s" % classlabel[i], "%10s" % str(num1),"%8s" % str(num2),"%12s" % str(num3),"%15s" % str(num4),"%7s" % str(total)
	  else:
	    print direct, "%12s" % str(num1),"%8s" % str(num2),"%12s" % str(num3),"%15s" % str(num4),"%7s" % str(total)
	    
      elif xvalue=='fnat':
	if classon:
	  print xvalue,'|  class |  > 0.8|  > 0.6|  > 0.4|  > 0.3|  > 0.2|  > 0.1|  < 0.1| total|'
	else:
	  print xvalue,'|  > 0.8|  > 0.6|  > 0.4|  > 0.3|  > 0.2|  > 0.1|  < 0.1| total|'
	  
	for i, direct in enumerate(dirlist):
	  xi=np.genfromtxt(direct+'/'+x)[:border]
	  num1=len(ma.compressed(ma.masked_outside(xi,0.1,0.2000001)))
	  num2=len(ma.compressed(ma.masked_outside(xi,0.2,0.3000001)))
	  num2b=len(ma.compressed(ma.masked_outside(xi,0.3,0.4000001)))
	  num3=len(ma.compressed(ma.masked_outside(xi,0.4,0.60000001)))
	  num4=len(ma.compressed(ma.masked_outside(xi,0.6,0.80000001)))
	  num5=len(ma.compressed(ma.masked_outside(xi,0.8,1.00000001)))
	  total=len(xi)
	  test=len(ma.compressed(ma.masked_greater(xi,0.1)))
	  if classon:
	    print direct, "%10s" % classlabel[i], "%6s" % str(num5),"%7s" % str(num4),"%7s" % str(num3),"%7s" % str(num2b),"%7s" % str(num2),"%7s" % str(num1), "%8s" % str(test), "%6s" % str(total)
	  else:
	    print direct, "%8s" % str(num5),"%7s" % str(num4),"%7s" % str(num3),"%7s" % str(num2b),"%7s" % str(num2),"%7s" % str(num1), "%8s" % str(test), "%6s" % str(total)









