import sys, os
import numpy as np
import numpy.ma as ma


if '--supplement' in sys.argv:
  sup = True
  supi = 2
else:
  sup = False
  supi = 1

if '--sorton' in sys.argv:
  sortons = sys.argv[sys.argv.index('--sorton')+1]
  cutmin=-float(sys.argv[sys.argv.index('--sorton')+2])
  sorton = -np.genfromtxt(sortons)
  end = np.shape(sorton)[0]
  outnamesorton = os.path.splitext(sortons)[0]
  sortname = os.path.splitext(sortons)[1][1:]
  if sup:
    supsortons = sys.argv[sys.argv.index('--sorton')+3]
    supsorton = -np.genfromtxt(supsortons)
  if os.path.splitext(sortons)[1][1:6] == 'lrmsd' or os.path.splitext(sortons)[1][1:6] == 'irmsd':
    cutmin = -cutmin
    sorton = -sorton
    if sup:
      supsorton = -supsorton
else:	
  print 'please give features to sort on'
  sys.exit()

if '--extras' in sys.argv:
  numextra = int(sys.argv[sys.argv.index('--extras')+1])
  nameextra =[]
  extras = []
  for i in range(numextra):
    nameextra.append(sys.argv[sys.argv.index('--extras')+2+i*supi])
    if nameextra[i].split('.')[-1][1:5]=='rmsd':
      extras.append(np.genfromtxt(sys.argv[sys.argv.index('--extras')+2+i*supi])[:end,-1])
      if sup:
	extras.append(np.genfromtxt(sys.argv[sys.argv.index('--extras')+2+i*supi+1])[:end,-1])      
    elif nameextra[i].split('.')[-1][1:5]=='dat':
      print '.dat files from Attract cannot be handled. Only Energy files with only one entry can be processed!'
      sys.exit() #has to be implemented
    else:
      extras.append(np.genfromtxt(sys.argv[sys.argv.index('--extras')+2+i*supi])[:end])
      if sup:
	extras.append(np.genfromtxt(sys.argv[sys.argv.index('--extras')+2+i*supi+1])[:end])

  
if '--numset' in sys.argv:
  full = int(sys.argv[sys.argv.index('--numset')+1])
else:
  full = 100000

##### delete good structures in the top x% or in the last -x% ####
delfraction = ''
if '--deletefraction' in sys.argv:
  fraction = float(sys.argv[sys.argv.index('--deletefraction')+1])
  if np.sign(fraction) == -1:
    delfraction = 'best'+str(int(100+fraction))
    beginfrac = int((100.+fraction)*end/100.)
    delfrac = ma.nonzero(ma.masked_greater(sorton[beginfrac:],cutmin))[0]+beginfrac
    fullgrids=np.delete(fullgrids,delfrac, axis=-2)
    sorton=np.delete(sorton,delfrac,axis=0)
    if '--extras' in sys.argv:
      extras = np.delete(extras,delfrac,axis=1)
  elif np.sign(fraction) == 1:
    delfraction = 'last'+str(int(100-fraction))
    beginfrac = int(fraction*end/100.)
    delfrac = ma.nonzero(ma.masked_greater(sorton[:beginfrac],cutmin))[0]
    fullgrids=np.delete(fullgrids,delfrac, axis=-2)
    sorton=np.delete(sorton,delfrac,axis=0)
    if '--extras' in sys.argv:
      extras = np.delete(extras,delfrac,axis=1)

  
###sort good structures in front of the grid

if '--sortorig' in sys.argv:
  resort = '-resorted'+sortname+str(cutmin)
  sorti=np.argsort(sorton[:])
  sorts=np.arange(len(sorti))
  length=ma.size(ma.nonzero(ma.masked_greater(sorton[sorti],cutmin)))
  if length==0:
    print 'no good structures found in orignal decoyset'
  sorting=np.append(sorti[:length], np.delete(sorts,sorti[:length]))

else:
  resort = ''
  sorting = np.arange(len(sorton))
  length = 0
  

outsorton = sorton[sorting]

if '--extras' in sys.argv:
  outextras = []
  for i in range(numextra):
    outextras.append(extras[i*supi][sorting])
  outextras = np.array(outextras)
  
outsorton=outsorton[:full]
if '--extras' in sys.argv:
  outextras= outextras[:,:full]

if sup == False:
    
    if sortname[:5] == 'lrmsd' or sortname[:5] == 'irmsd':
      np.savetxt(outnamesorton+resort+delfraction+'-'+str(full)+'.'+sortname,outsorton, fmt=["%s","%3.3f"])
    else:
      np.savetxt(outnamesorton+resort+delfraction+'-'+str(full)+'.'+sortname,-outsorton, fmt=["%3.3f"])  
    if '--extras' in sys.argv:
      for i in range(numextra):
        if os.path.splitext(nameextra[i])[1][1:6] == 'irmsd' or os.path.splitext(nameextra[i])[1][1:6] == 'lrmsd':
	  np.savetxt(os.path.splitext(nameextra[i])[0]+resort+delfraction+'-'+str(full)+os.path.splitext(nameextra[i])[1],np.array(zip(np.arange(1,len(outextras[i])+1),outextras[i])), fmt=["%d","%3.3f"])
        else:
	  np.savetxt(os.path.splitext(nameextra[i])[0]+resort+delfraction+'-'+str(full)+os.path.splitext(nameextra[i])[1],outextras[i], fmt=["%3.3f"])
		
###add good structures from constrained grid to original grid

elif sup == True:
    maske=ma.nonzero(ma.masked_greater(supsorton,cutmin))[0]
    
    length2=len(maske)
    if length2==0:
      print 'no good structures found to be supplemented'

    supplesorton = supsorton[maske]
    
    if '--extras' in sys.argv:
      suppleextra = []
      for i in range(numextra):
	suppleextra.append(extras[i*supi+1][maske])
      suppleextra = np.array(suppleextra)
    
    aussorton=np.append(supplesorton,outsorton,axis=0)[:full]
    if '--extras' in sys.argv:
      ausextra = np.append(suppleextra, outextras, axis = 1)[:,:full]
         
    if sortname[:5] == 'lrmsd' or sortname[:5] == 'irmsd':
      np.savetxt(outnamesorton+resort+'-'+str(full)+'-sup'+sortname+str(cutmin)+'.'+sortname,aussorton, fmt=["%s","%3.3f"])
    else:
      np.savetxt(outnamesorton+resort+'-'+str(full)+'-sup'+sortname+str(cutmin)+'.'+sortname,-aussorton, fmt=["%3.3f"])
    for i in range(numextra):
      if os.path.splitext(nameextra[i])[1][1:6] == 'irmsd' or os.path.splitext(nameextra[i])[1][1:6] == 'lrmsd':
	np.savetxt(os.path.splitext(nameextra[i])[0]+resort+'-'+str(full)+'-sup'+sortname+str(cutmin)+os.path.splitext(nameextra[i])[1],np.array(zip(np.arange(1,len(ausextra[i])+1), ausextra[i])), fmt=["%d","%3.3f"])
      else:
	np.savetxt(os.path.splitext(nameextra[i])[0]+resort+'-'+str(full)+'-sup'+sortname+str(cutmin)+os.path.splitext(nameextra[i])[1],ausextra[i], fmt=["%3.3f"])
 
