#!/bin/bash
#PBS -N buried-surface-wrad0_8
#PBS -m ae
#PBS -M alexander.sasse@tum.de
#PBS -e localhost:$PBS_O_WORKDIR/$PBS_JOBNAME-out.err
#PBS -o localhost:$PBS_O_HOME/report/$PBS_JOBNAME-out.log
#PBS -S /bin/bash
#PBS -l nodes=1:ppn=1
###PBS -l mem=1g
#PBS -l walltime=999:00:00
#PBS -q ethernet 

#cd $PBS_O_WORKDIR

# coarse grained buried SA in Attracts representation
python ../../asa.py receptor-cg.pdb ligand-cg.pdb out_unbound.dat attract --coarse_grained

# atomistic BSA in Gaa with smaller size of waterprobe
python ../../asa.py receptor-gaa.pdb ligand-gaa.pdb out_unbound-sorted-dr.dat gaa --watersize 0.8 

# Calculate total BSA's 
python ../../asa.py receptor-gaa.pdb ligand-gaa.pdb out_unbound-sorted-dr.dat buriedsa --watersize 1.4