#!/bin/bash
#PBS -N gaa-grid-dist
#PBS -m ae
#PBS -M alexander.sasse@tum.de
#PBS -e localhost:$PBS_O_WORKDIR/$PBS_JOBNAME-out.err
#PBS -o localhost:$PBS_O_HOME/report/$PBS_JOBNAME-out.log
#PBS -S /bin/bash
#PBS -l nodes=1:ppn=1
###PBS -l mem=1g
#PBS -l walltime=999:00:00
#PBS -q ethernet 

#cd $PBS_O_WORKDIR

#creation of step potential pre-grids 
python ../../collect-function.py ../../out.dat --proteinmodel GAA receptor-refe-gaa.pdb ligand-refe-gaa.pdb --gridtype none --polationparams 10. 0. 10. --output pregrid-gaa-bins-10.npy

#creation of vdw pre-grids
python ../../collect-function.py out_unbound-sorted-dr.dat --proteinmodel gaa receptor-gaa.pdb ligand-gaa.pdb --gridtype distances --polationparams 8. 2. 10. --powers 2 8. 6. --output pregrid-gaa-distances-2to10A-power8and6.npy 

#resort pre-grids by capri-stars
python ../../decoysetmixer.py --grids pregrid-gaa-distances-2to10A-power8and6.npy --sorton out_unbound-sorted-dr.capstars 1 --numset 3000 --sortorig

#supplement the grid with near-native structures from another decoy-set
python ../../decoysetmixer.py --supplement --grids pregrid-gaa-bin-7.npy pregrid-gaa-true-interface-bin-7.npy --sorton out_unbound-sorted-dr.capstars 1 out_unbound-true-interface-sorted-dr.capstars --extras 3 out_unbound-sorted-dr.fnat out_unbound-true-interface-sorted-dr.fnat out_unbound-sorted-dr.irmsd out_unbound-true-interface-sorted-dr.irmsd out_unbound-sorted-dr.lrmsd out_unbound-true-interface-sorted-dr.lrmsd --numset 5000
