#!/bin/bash
#PBS -N rescoring-newpar
#PBS -m ae
#PBS -M alexander.sasse@tum.de
#PBS -e localhost:$PBS_O_WORKDIR/$PBS_JOBNAME-out.err
#PBS -o localhost:$PBS_O_HOME/report/$PBS_JOBNAME-out.log
#PBS -S /bin/bash
#PBS -l nodes=1:ppn=2
###PBS -l mem=1g
#PBS -l walltime=999:00:00
#PBS -q ethernet 

#cd $PBS_O_WORKDIR

#Free scoring with @rank.py
python ../../@rank.py --input out_unbound-sorted-dr.dat --proteinmodel attract *A-unboundr.pdb *B-unboundr.pdb --vdwpotential ../MC-Paramatrix_160409-attractsaddel8-6-2to10A-resorted-normal005-constrain01-5_0_20-papercv1_parm.par --shift 2 --vdwcutoff 10 --vdwfunctiontype attract --printout > MC-Paramatrix_160409-attractsaddel8-6-2to10A-resorted-normal005-constrain01-5_0_20-papercv1_parm.rescore

#rescoring on the pre-calculated grids
python ../../grid-rescore.py pregrid-gaa-bin-10.npy ../MC-Paramatrix_gaa-bin10-scaled-average.par --gridtype step 1 27 > MC-Paramatrix_gaa-bin10-scaled-average.rescore

python ../../grid-rescore.py surfacegrid-gaa.npy ../LinReg-Parameter_gaa-bsa-scaled-average.par --gridtype step 0 27 > LinReg-Parameter_gaa-bsa-scaled-average.rescore

python ../../grid-rescore.py pregrid-gaa-distances-2to10A-power8and6.npy ../MC-Paramatrix_gaadistancespower8-6-to10A.par --gridtype distances 2 27 1 2 1 2 > MC-Paramatrix_gaadistancespower8-6-to10A.rescore

python ../../grid-rescore.py pregrid-attract-spline8-2to10-in0_4.npy ../MC-Paramatrix-attractsaddel8-6-2to10A.par --gridtype interpolate 3 32 2 10 0.4 0 8 6 > MC-Paramatrix_attractsaddel8-6-2to10A.rescore



