#!/bin/bash
#PBS -N gaa-test
#PBS -m ae
#PBS -M alexander.sasse@tum.de
#PBS -e localhost:$PBS_O_WORKDIR/$PBS_JOBNAME-out.err
#PBS -o localhost:$PBS_O_HOME/report/$PBS_JOBNAME-out.log
#PBS -S /bin/bash
#PBS -l nodes=1:ppn=12
###PBS -l mem=1g
#PBS -l walltime=999:00:00
#PBS -q ethernet 

#cd $PBS_O_WORKDIR

#Vdw Potential with constraints
python ../training-MC.py --complexes Bench.txt 5 --grid pregrid-gaa-distances-2to10A-power8and6-resorted-capstars.npy 3000 distances 1 2 1 2 --mcparams normal 0.05 300000 positionlinear exponential 100 keepsign saddle 8 6 --evaluate out_unbound-sorted-dr-resorted-capstars.capstars capstars --preparameter random 2 378 --output outname matrix --searchrange 0.1 5. -20. 20 -2 2

#step potential training until validation set converges
python ../training-MC.py --complexes Bench.txt 5 --grid pregrid-gaa-bin-10-resorted-capstars.npy 3000 step --mcparams adaptive 1. 100000 positionquadratic ziczac 100 normal normal --evaluate out_unbound-sorted-dr-resorted-capstars.capstars capstars --preparameter random 1 378 --converge 1000 --output outname matrix

# BSA-potential with ordinary least squares fit
python ../training-glm.py --complexes Bench.txt 5 --grid surfacegrid-gaa-resorted-capstars.npy 3000 step --functionshape 0 27 --evaluate out_unbound-sorted-dr-resorted-capstars.capstars capstars --regressiontype ols --preprocessing meancomplex --output outname normal

# spline interpolation for complex potential form used by Attract
python ../training-MC.py --complexes Bench.txt 5 --grid pregrid-attract-spline8-2to10-in0_4-resorted-capstars.npy 2000 interpolate 2. 10. 0.4 --mcparams normal 0.05 1000000 positionquadratic ziczac 20 interpolate 0 8 6 --evaluate out_unbound-sorted-dr-resorted-capstars.capstars capstars --preparameter random 3 528 --output outname matrix --searchrange 2. 5. -20. 20 -2 2


